/*
Reading a serial ASCII-encoded string.

This sketch demonstrates the Serial parseInt() function.
It looks for an ASCII string of comma-separated values.
It parses them into ints, and uses those to fade an RGB LED.

Circuit: Common-anode RGB LED wired like so:
 * Red cathode: digital pin 3
 * Green cathode: digital pin 5
 * blue cathode: digital pin 6
 * anode: +5V

created 13 Apr 2012
by Tom Igoe

This example code is in the public domain.
 */

int r1=0;
int r2=0;
int r3=0;
int r4=0;

int sync1 = 0;
int sync2 = 0;
int robot = 3;

int sleep=0;
// pins for the LEDs:
const int redPin = 10;
const int greenPin = 9;
const int bluePin =11;

const int upswitch = A0;
const int downswitch = A1;

const int pwm = 6;
const int dir = 7;

const int slow = 50;
const int fast = 150;


int redsleep[] = {255,0,0,255,255,255,255};
int greensleep[] = {0,255,0,120,0,80,255};
int bluesleep[] = {0,0,255,0,255,0,255};
int red=0;
int green=0;
int blue=0;
int value;
long time=0;
int periode = 2000;

int sleepflag=0;
int sleeptime=0;
int sleeptimenew=0;

int fadeperiod = 400;
int blinkperiod = 100;

int redval=0;
int blueval=0;
int greenval=0;

int leffect=0;

int motorspeed=0;
int motordir=0;

int upswitchstate=0;
int downswitchstate=0;

int count=0;

int upflag=0;
int downflag=0;
void setup() {
  // initialize serial:
  Serial.begin(9600);
  // make the pins outputs:
  pinMode(redPin, OUTPUT);
  pinMode(greenPin, OUTPUT);
  pinMode(bluePin, OUTPUT);
  
  pinMode(upswitch, INPUT_PULLUP);
  pinMode(downswitch, INPUT_PULLUP);
  
  pinMode(pwm, OUTPUT);
  pinMode(dir, OUTPUT);
  
  //setPwmFrequency(pwm, 1);
  
}

void loop() {
  // if there's any serial available, read it:
  while (Serial.available() > 0) {
    
    
    sync1 = Serial.parseInt();
    sync2 = Serial.parseInt();
    
    
    
    
    if(sync1 == 999)
    {
      
      if(sync2 = 45)
      {
        
        r1 = Serial.parseInt();
        r2 = Serial.parseInt();
        r3 = Serial.parseInt();
        r4 = Serial.parseInt();
        
        if(r3 == 1)
        {
          
          leffect = Serial.parseInt();
          red = Serial.parseInt();
          green = Serial.parseInt();
          blue = Serial.parseInt();
          
          motorspeed = Serial.parseInt();
          motordir = Serial.parseInt();
          
          fadeperiod = Serial.parseInt();
          blinkperiod = Serial.parseInt();
          sleep = Serial.parseInt();
          
          
          if (Serial.read() == '\n') {
            
            break;
            
          }
          
        }
        
      }
    }
    
    // look for the next valid integer in the incoming serial stream:
    
    
    // look for the newline. That's the end of your
    // sentence:
    
  }
  
  time = millis();
  
  if(sleepflag==0)
  {
    sleeptime=millis();
  }
  
  
  if(sleep==1)
  {
    
    sleepflag=1;
    
    sleeptimenew = (millis() - sleeptime);
    
    if(sleeptimenew > fadeperiod)
    {
      sleeptime = millis();
      
      count++;
      if(count>6)
        count=0;
    }
    
    
    redval =redsleep[count]*0.5*(1+cos(2*(PI/fadeperiod)*sleeptimenew - PI));
    blueval = bluesleep[count]*0.5*(1+cos(2*(PI/fadeperiod)*sleeptimenew  - PI));
    greenval = greensleep[count]*0.5*(1+cos(2*(PI/fadeperiod)*sleeptimenew  - PI));
    
    analogWrite(redPin, redval);
    analogWrite(greenPin, greenval);
    analogWrite(bluePin, blueval);
    
  }
  
  else
  {
    sleepflag=0;
    
    if(leffect==2)
    {
      redval =red*0.5*(1+cos(2*(PI/fadeperiod)*time - PI));
      blueval = blue*0.5*(1+cos(2*(PI/fadeperiod)*time  - PI));
      greenval = green*0.5*(1+cos(2*(PI/fadeperiod)*time  - PI));
      
      
      analogWrite(redPin, redval);
      analogWrite(greenPin, greenval);
      analogWrite(bluePin, blueval);
      
    }
    
    
    else if(leffect==1)
    {
      redval =red*0.5*(1+cos(2*(PI/blinkperiod)*time - PI));
      blueval = blue*0.5*(1+cos(2*(PI/blinkperiod)*time  - PI));
      greenval = green*0.5*(1+cos(2*(PI/blinkperiod)*time  - PI));
      
      if(redval>=red/2)
      {
        redval=red;
      }
      
      else
      {
        redval=0;
      }
      
      
      
      if(greenval>=green/2)
      {
        
        greenval=green;
        
      }
      
      else
      {
        
        greenval=0;
        
      }
      
      
      
      if(blueval>=blue/2)
      {
        blueval=blue;
      }
      
      else
      {
        blueval=0;
      }
      
      
      
      
      analogWrite(redPin, redval);
      analogWrite(greenPin, greenval);
      analogWrite(bluePin, blueval);
      
    }
    
    else if(leffect==0)
    {
      
      analogWrite(redPin, red);
      analogWrite(greenPin, green);
      analogWrite(bluePin, blue);
      
    }
    
    
  }
  
  
  
  upswitchstate = digitalRead(upswitch);
  downswitchstate = digitalRead(downswitch);
  
  
  
  if(motordir==0)
    analogWrite(pwm,0);
  
  if(motordir==1)
  {
    if(upswitchstate==1)
    {
      digitalWrite(dir,LOW);
      analogWrite(pwm,motorspeed);
    }
    else
    {
      analogWrite(pwm,0);
    }
  }
  
  else if(motordir==2)
  {
    if(downswitchstate==1)
    {
      digitalWrite(dir,HIGH);
      analogWrite(pwm,motorspeed);
    }
    else
    {
      analogWrite(pwm,0);
    }
  }
  
  
  
  
  else if(motordir==3)
  {
    if(upswitchstate==0)
    {
      upflag=1;
      downflag=0;
    }
    
    if(downswitchstate==0)
    {
      upflag=0;
      downflag=1;
    }
    
    
    if(upflag==1)
    {
      digitalWrite(dir,HIGH);
      analogWrite(pwm,motorspeed);
    }
    
    
    if(downflag==1)
    {
      digitalWrite(dir,LOW);
      analogWrite(pwm,motorspeed);
    }
    
    
  }
  
  
  
  
  else
    analogWrite(pwm,0);
  
}


void setPwmFrequency(int pin, int divisor) {
  byte mode;
  if(pin == 5 || pin == 6 || pin == 9 || pin == 10) {
    switch(divisor) {
      case 1: mode = 0x01; break;
      case 8: mode = 0x02; break;
      case 64: mode = 0x03; break;
      case 256: mode = 0x04; break;
      case 1024: mode = 0x05; break;
      default: return;
    }
    if(pin == 5 || pin == 6) {
      TCCR0B = TCCR0B & 0b11111000 | mode;
      } else {
      TCCR1B = TCCR1B & 0b11111000 | mode;
    }
    } else if(pin == 3 || pin == 11) {
    switch(divisor) {
      case 1: mode = 0x01; break;
      case 8: mode = 0x02; break;
      case 32: mode = 0x03; break;
      case 64: mode = 0x04; break;
      case 128: mode = 0x05; break;
      case 256: mode = 0x06; break;
      case 1024: mode = 0x7; break;
      default: return;
    }
    TCCR2B = TCCR2B & 0b11111000 | mode;
  }
}






